!addr zp_src = $fb
!addr zp_dst = $fd
sys          = $9e
rem          = $8f

* = $801

; basic header
!word line2:!byte 10,0,sys,$20:!for i,3,0 {!pet '0'+start%10^(i+1)/10^i}
!byte ":",rem,$20:!pet "*** ram skan 64 ***",0
line2: !word line3:!byte 20,0,rem,$20:!pet "19-aug-2024 by k. krausnick",0
line3: !word line4:!byte 30,0,rem,$20:!pet "press cursor keys to move around",0
line4: !word line5:!byte 40,0,rem,$20:!pet " space = reset address",0
line5: !word line6:!byte 50,0,rem,$20:!pet "return = nearest page boundary",0
line6: !word line7:!byte 60,0,rem,$20:!pet " f5/f6 = -+16 bytes",0
line7: !word line8:!byte 70,0,rem,$20:!pet " f7/f8 = -+4k bytes",0
line8: !word prgend:!byte 80,0,rem,$20:!pet "  stop = quit",0
prgend: !fill 2,0

start:
  lda #$0b
  sta $d020
  lda #$00
  sta $d021
  lda #$05
  sta $286
  lda #$93
  jsr $ffd2
  lda #$0d
  sta $286
  sta $d800
  lda #$80
  sta $28a     ; enable key repeat
  ldy #$03
  jsr set_curs
  ldx #$00
- lda banner,x
  beq +
  jsr $ffd2
  inx
  bne -
+ inc last_word
  inc last_byte

main:
  jsr $ffe4
  bne +
  jmp m_end
+ cmp #' '     ; space to reset
  bne +
  lda #$00
  sta zp_src
  sta zp_src+1
  inc last_word
  inc last_byte
  jmp m_end
+ cmp #$11     ; cursor down
  bne +
  inc zp_src+1 ; page down
+ cmp #$91     ; cursor up
  bne +
  dec zp_src+1 ; page up
+ cmp #$1d     ; cursor right
  bne +
  inc zp_src   ; byte down
  bne +
  inc zp_src+1
+ cmp #$9d     ; cursor left
  bne ++
  ldy zp_src
  bne +
  dec zp_src+1
+ dec zp_src   ; byte up
++ cmp #$8b    ; f6 = 16 bytes down
  bne +
  lda zp_src
  clc
  adc #$10
  sta zp_src
  bcc m_end
  inc zp_src+1
  jmp m_end
+ cmp #$87     ; f5 = 16 bytes up
  bne +
  lda zp_src
  sec
  sbc #$10
  sta zp_src
  bcs m_end
  dec zp_src+1
  jmp m_end
+ cmp #$8c     ; f8 = 4k bytes down
  bne +
  lda zp_src+1
  clc
  adc #$10
  sta zp_src+1
  jmp m_end
+ cmp #$88     ; f7 = 4k bytes up
  bne +
  lda zp_src+1
  sec
  sbc #$10
  sta zp_src+1
  jmp m_end
+ cmp #$0d     ; return = nearest page
  bne m_end
  lda zp_src
  bpl +
  inc zp_src+1
+ lda #$00
  sta zp_src
m_end:
  jsr show_ram
  lda $91      ; stop key pressed
  bpl +
  jmp main
+ lda #$93
  jsr $ffd2
  rts

show_ram:
  lda #$04
  sta zp_dst+1
  ldy #$00
  sty zp_dst
  ldx zp_src+1
- lda (zp_src),y
  sta (zp_dst),y
  lda zp_dst+1
  cmp #$07
  bne +
  cpy #$bf
  bcs ++
+ iny
  bne -
  inc zp_src+1
  inc zp_dst+1
  bne -
++ stx zp_src+1

; show banner
  lda zp_src
  cmp last_word
  bne +
  lda zp_src+1
  cmp last_word+1
  beq ++

; address location hex/dec
+ lda zp_src
  sta last_word
  lda zp_src+1
  sta last_word+1
  ldy #$0d
  jsr set_curs
  lda zp_src+1
  jsr hex_byte
  lda zp_src
  jsr hex_byte
  ldy #$12
  jsr set_curs
  ldx #$00
  lda #' '
- sta $7d3,x
  inx
  cpx #$04
  bne -
  lda zp_src+1
  ldx zp_src
  jsr $bdcd    ; print 16-bit number (a = hi, x = lo)

; value at address hex/dec
++ lda $400
  cmp last_byte
  beq +
  sta last_byte
  ldy #$1f
  jsr set_curs
  lda $400
  jsr hex_byte
  lda #' '
  sta $7e3
  sta $7e4
  ldy #$22
  jsr set_curs
  lda #$00
  ldx $400
  jsr $bdcd    ; print 16-bit number (a = hi, x = lo)
+ rts

set_curs:
  ldx #$18
  clc
  jsr $fff0
  rts

hex_byte:
  pha
  lsr
  lsr
  lsr
  lsr
  jsr hex_out
  pla
  and #$0f
  jsr hex_out
  rts

hex_out:
  sed
  cmp #$0a
  adc #$30
  cld
  jsr $ffd2
  rts

last_word: !word $ffff
last_byte: !fill 1
banner:    !pet "address: $    /       val: $  /",0